'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

process.on('unhandledRejection', function (e) {
  throw e;
});

// TODO
// - Use init-package-json.
// - Use promises.

function main() {
  var fs, path, cwd, modifyPackageJson, replaceFile, _require, spawnSync, init, _, inquirer, _require2, promisify, Promise, gulpfileContents, confirm, answers;

  return _regeneratorRuntime.async(function main$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        fs = require('fs');
        path = require('path');
        cwd = require('cwd');
        modifyPackageJson = require('./util/modifyPackageJson');
        replaceFile = require('./util/replaceFile');
        _require = require('child_process');
        spawnSync = _require.spawnSync;
        init = require('init-package-json');
        _ = require('lodash');
        inquirer = require('inquirer');
        _require2 = require('bluebird');
        promisify = _require2.promisify;
        Promise = require('bluebird');

        //endregion

        // npm init

        if (!fs.existsSync(cwd('package.json'))) {
          console.log('Initializing npm package...');
          spawnSync('npm init -f');
          //init(cwd(), 'package.json', {}, (e, data) => {
          //})
        }

        // gulp

        console.log('Adding gulp to package.json');

        context$1$0.next = 17;
        return _regeneratorRuntime.awrap(promisify(modifyPackageJson)(function (json) {
          _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js');
          return json;
        }));

      case 17:

        // gulpfile.js

        console.log('Updating gulpfile...');

        gulpfileContents = "var gulp = require('gulp')\n" + "require('babelator')(gulp)\n";
        context$1$0.next = 21;
        return _regeneratorRuntime.awrap(promisify(replaceFile)(cwd('gulpfile.js'), gulpfileContents));

      case 21:

        // Add babelator dependency

        console.log('Adding babelator dependency...');

        confirm = function confirm(message) {
          return new Promise(function (resolve, reject) {
            inquirer.prompt([{ type: 'confirm', name: 'confirm', message: message }], function (answers) {
              resolve(answers);
            });
          });
        };

        answers = null;
        context$1$0.next = 26;
        return _regeneratorRuntime.awrap(confirm('Run `npm i -D babelator gulpjs/gulp.git#4.0`?'));

      case 26:
        answers = context$1$0.sent;

        if (!answers.confirm) {
          context$1$0.next = 31;
          break;
        }

        spawnSync('npm', ['i', '-D', 'babelator', 'gulpjs/gulp.git#4.0'], { stdio: 'inherit' });
        context$1$0.next = 35;
        break;

      case 31:
        context$1$0.next = 33;
        return _regeneratorRuntime.awrap(confirm('Run `npm link -D babelator gulp`?'));

      case 33:
        answers = context$1$0.sent;

        if (answers.confirm) spawnSync('npm', ['link', 'babelator', 'gulp'], { stdio: 'inherit' });

      case 35:
        // Instructions
        console.log('Please run `npm install`');
        console.log('Please run `npm install`');
        console.log('Tip: Use `npm_lazy` module to locally cache npm modules.');

      case 38:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this);
}

function cli() {
  main().then(function () {});
}

module.exports = cli;

//region Imports

// TODO(vjpr): Provide options instead of 2 confirms. Duh!