///
/// Tasks for `pre-git` module.
///

//region Imports
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var cwd = require('cwd');
//endregion

exports['default'] = function (gulp, opts) {

  gulp.task('pre-git:prepush', gulp.series('build', 'test', 'lint'));

  gulp.task('pre-git:pre-commit', gulp.series('lint'));

  gulp.task('pre-git:bootstrap', function (done) {
    var modifyPackageJson = require('../util/modifyPackageJson');
    var _ = require('lodash');

    modifyPackageJson(function (json) {
      // TODO(vjpr): Temporarily disabled.
      //_.set(json, 'pre-commit', 'gulp pre-git:pre-commit')
      //_.set(json, 'post-commit', 'git status')
      _.set(json, 'pre-push', [
        // This might be too slow for some modules.
        //'rimraf node_modules',
        //'npm install',
        // This might be too slow also as we use `cut-release` which
        // would mean it would run twice.
        //'gulp pre-git:prepush',
        // TODO(vjpr): We should not use cut-release. It should be included in here.
      ]);
      return json;
    }, done);
  });
};

module.exports = exports['default'];