'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (gulp, opts) {

  var tsDestDir = 'lib-ts';
  var tsDestDirJS = tsDestDir + '/js';
  var tsDestDirDefinitions = tsDestDir + '/definitions';

  gulp.task('typescript:clean', function () {
    var del = require('del');
    var gutil = require('gulp-util');

    gutil.log('Cleaning:', gutil.colors.red(tsDestDir));
    return del(tsDestDir + '/**/*');
  });

  gulp.task('typescript:compile', function () {
    var sourcemaps = require('gulp-sourcemaps');
    var ts = require('gulp-typescript');
    var merge = require('merge2');

    var tsProject = ts.createProject({
      declaration: true,
      noExternalResolve: true
    });

    var tsResult = gulp.src(opts.srcDir + '/**/*.ts').pipe(sourcemaps.init()).pipe(ts(tsProject));

    // Merge the two output streams, so this task is finished when the IO of both operations are done.
    return merge([tsResult.dts.pipe(gulp.dest(tsDestDirDefinitions)), tsResult.js.pipe(sourcemaps.write()).pipe(gulp.dest(tsDestDir))]);
  });

  gulp.task('typescript:watch', gulp.series('typescript:compile', function watcher() {
    gulp.watch('lib/*.ts', gulp.series('typescript:compile'));
  }));
};

module.exports = exports['default'];