'use strict';

module.exports = function (fn, done) {
  var jsondiffpatch = require('jsondiffpatch');
  var confirm = require('inquirer-confirm');
  var fs = require('fs');
  var cwd = require('cwd');
  var _ = require('lodash');
  var chalk = require('chalk');

  var pjsonPath = cwd('package.json');
  var oldJson = require(pjsonPath);
  var json = _.cloneDeep(oldJson);
  json = fn(json);
  var delta = jsondiffpatch.diff(oldJson, json);
  if (!delta) return done();
  console.log('\n' + chalk.underline('Proposed changes to:'), pjsonPath);
  jsondiffpatch.console.log(delta);
  confirm('Update package.json?').then(function () {
    console.log('Writing file');
    fs.writeFileSync(pjsonPath, JSON.stringify(json, null, 2));
    done();
  }, function () {
    done('Cancelled.');
  });
};