//region Imports
var path = require('path')
var fs = require('fs')
var _ = require('lodash')
//endregion

function getConfigPath() {
  return path.join(process.cwd(), './babelator.js')
}

function getConfig() {
  let opts = {}
  // If `babelator.js` exists, grab config settings from there.
  var babelatorConfigPath = getConfigPath()
  if (fs.existsSync(babelatorConfigPath)) {
    opts = require(babelatorConfigPath)
  }
  return opts
}

function main() {

  var opts = getConfig()

  opts = _.defaults(opts, {
    srcDir: 'src',
    destDir: 'lib',
    shouldCompileTests: true,
    //eslintrc: {}
    //mocha: {},
    //babel: {}
  })

  // Computed config.
  opts.srcGlob = opts.srcDir + '/**/*.js'
  opts.destGlob = opts.destDir + '/**/*'
  opts.testsGlob = opts.srcDir + '/**/__tests__/**/*-test.js'
  opts.testsDestGlob = opts.destDir + '/**/__tests__/**/*-test.js' // Transpiled tests.

  return opts

}

main.getConfigPath = getConfigPath

module.exports = main
