//region Imports
const cwd = require('cwd')
//endregion

export default function(gulp, opts) {

  const makeBumpTask = type => {

    const bumpTask = () => {
      const bump = require('gulp-bump')

      return gulp.src(['./package.json'])
        .pipe(bump({type}))
        .pipe(gulp.dest('./'))
    }
    return gulp.series(bumpTask, 'bump:git:confirm', 'bump:git:add', 'bump:git:commit', 'bump:git:commit-tag')
  }

  gulp.task('bump:git:confirm', (done) => {
    done()
    // TODO(vjpr): Check if working directory is empty.
    //git.status({quiet: true}, (e, stdout) => {
    //  console.log(e, stdout)
    //})
  })

  gulp.task('bump:git:add', () => {
    const git = require('gulp-git')

    return gulp.src('./package.json').pipe(git.add())
  })

  gulp.task('bump:git:commit', () => {
    const git = require('gulp-git')

    const json = require(cwd('package.json'))
    const {version} = json
    return gulp.src('./package.json').pipe(git.commit(version))
  })


  gulp.task('bump:git:commit-tag', (done) => {
    const git = require('gulp-git')

    const json = require(cwd('package.json'))
    const {version} = json
    git.tag('v' + version, 'Bump', e => {
      if (e) return done(e)
      done()
    })
  })

  gulp.task('bump:patch', makeBumpTask('patch'))
  gulp.task('bump:minor', makeBumpTask('minor'))
  gulp.task('bump:major', makeBumpTask('major'))
  gulp.task('bump', makeBumpTask('patch'))

}
