//region Imports
const cwd = require('cwd')
const path = require('path')
//endregion

export default (gulp, opts) => {

  // NOTE: Ordered by most time consuming.
  gulp.task('npm:prepublish', gulp.series('build', 'lint', 'mocha:lib:run'))
  gulp.task('npm:bootstrap:pjson', (done) => {
    const modifyPackageJson = require('../util/modifyPackageJson')
    const _ = require('lodash')

    modifyPackageJson((json) => {
      _.set(json, 'scripts.prepublish', 'npm run gulp prepublish')
      _.set(json, 'main', path.join(opts.destDir, 'index.js'))
      _.set(json, 'license', 'MIT')
      return json
    }, done)
  })
  gulp.task('npm:bootstrap:copy-files', (done) => {
    const replaceFile = require('../util/replaceFile')

    const contents = 'node_modules\n'
    replaceFile(cwd('.npmignore'), contents, done)
  })
  gulp.task('npm:bootstrap', gulp.series('npm:bootstrap:pjson', 'npm:bootstrap:copy-files'))

}
